# class Crystal::Macros::TypeDeclaration

- Crystal::Macros::TypeDeclaration
- Crystal::Macros::ASTNode

##
Overview

A type declaration like `x : Int32`

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #type : ASTNode

  Returns the type part of the declaration.

- #value : ASTNode | Nop

  The value assigned to the variable, if any.

- #var : MacroId

  Returns the variable part of the declaration.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def type : ASTNode #

Returns the type part of the declaration.

def value : ASTNode | Nop #

The value assigned to the variable, if any.

def var : MacroId #

Returns the variable part of the declaration.